#!/usr/local/bin/perl
use Cwd;

#Use current directory as root
$cosmomc = cwd;

$params =  $ARGV[0];
$num = $ARGV[1];
$start = $ARGV[2];
if ($start == '') {$start = 1;}

$path = "/scratch/antlewis";
#$cosmomc = "/home/antlewis/cosmomc";

for ($i=$start; $i<=$num+$start -1; $i++){

open(Fout,">./scripts/script_$i");
print Fout <<EMP;
#!/bin/csh -f
#PBS -N cosmomc
#PBS -l nodes=1:ppn=2
#PBS -q workq
#PBS -l mem=100mb
#
cd $cosmomc
cat \$PBS_NODEFILE > scripts/$params.cpu$i
cp cosmomc $path/cosmomc_$params
nice +19 $path/cosmomc_$params $params.ini $i > $path/$params.log_$i
mv $path/$params.log_$i $cosmomc/scripts
mv $path/$params* $cosmomc/chains
rm -f $path/cosmomc_$params
EMP
close(Fout);

chdir("./scripts");
@args=("qsub","./script_$i");
system(@args);
chdir("../");
}
