!Proposal density 
!Lots of arbitary choices to make here..
!Using the covariance matrix to give the proposal directions typcially
!significantly increases the acceptance rate and gives faster movement 
!arounGetProd parameter space.

module cycler
use settings

 integer :: loopix = 0
 integer looporder(num_params)

end module cycler

subroutine GetProposal(In, Out)
  use settings
  use Random
  use ParamDef
  use cycler
  implicit none
  type (ParamSet) In, Out
  double precision ranmar
  integer ix, i,j,i2, paramix,indices(num_params)
  logical doneinc
  real wid, tmp(num_params_used)

  integer propose_num_change


   propose_num_change = int(ranmar()*3)+1     
   doneinc =.true.

   if (oversample_fast > 1 .and. ranmar()*oversample_fast>1.) then
     
       ix = fast_params_used(int(ranmar()*num_fast_params_used)+1)

   else

       if(has_propose_matrix) then
           ix = params_used(int(ranmar()*num_params_used)+1)
       else
        if (mod(loopix,num_params_used*2) == 0) &
               call RandIndices(looporder, num_params_used, num_params_used)
        loopix = loopix + 1
        j = looporder(mod(loopix,num_params_used)+1)
        ix = params_used(j) 
       end if

   end if 

 
  Out= In

  wid = 1/sqrt(real(propose_num_change)) !Gaussian1()  !uncomment to use a e^{-|x|} like proposal here

  if (ix <= num_hard .or. has_propose_matrix .and. oversample_fast==0 ) then
    
     if (has_propose_matrix) then
        do
        tmp = 0
        do paramix = 1, propose_num_change
          if (mod(loopix,num_params_used*2) == 0) then
           call RandIndices(looporder, num_params_used, num_params_used)
          end if
         loopix = loopix + 1
         j = looporder(mod(loopix,num_params_used)+1)
   
        tmp(j) =  Gaussian1()*propose_diag(j)*wid
        end do

        Out%P(params_used) = Out%P(params_used) + MATMUL(propose_matrix,tmp)
    
        if (any(Out%P(1:num_hard) /= In%P(1:num_hard)) .or. oversample_fast==0)  exit 
        Out%P = In%P
       end do
 
     else

      do
        do i=1, min(num_hard,propose_num_change)
           if (.not. doneinc) then
               if (mod(loopix,num_params_used*2) == 0) &
                  call RandIndices(looporder, num_params_used, num_params_used)
               loopix = loopix + 1
               j = looporder(mod(loopix,num_params_used)+1)
               ix = params_used(j) 
           end if
           doneinc = .false.
           Out%P(ix) = Out%P(ix) + Gaussian1()*Scales%PWidth(ix)*wid
        end do
        if (any(Out%P(1:num_hard) /= In%P(1:num_hard)))  exit
        Out%P = In%P
      end do
     
    end if

   
  else 
    if (Feedback > 1) write (*,*) 'proposing change to fast params'
     !Fast parameters, for the moment change all together

     Out%P(ix) = Out%P(ix) + Gaussian1()*Scales%PWidth(ix)*wid
     if (propose_num_change/= 1 .and. num_fast_params_used/= 1) then
        call RandIndices(indices,num_fast_params_used, min(num_fast_params_used,propose_num_change-1))
        do i=1, min(num_fast_params_used-1,propose_num_change-1)
           i2 = fast_params_used(indices(i))
           if (i2 /= ix) Out%P(i2) = Out%P(i2) + Gaussian1()*Scales%PWidth(i2)*wid
        end do
     end if
  end if

end subroutine GetProposal
